<?php
/**
 * Created by PhpStorm.
 * User: PHOENIX
 * Date: 18.02.16
 * Time: 17:07
 */

namespace common\modules\triggers\components\conditions\conditions;


use common\modules\triggers\components\conditions\vendor\ConditionBase;
use common\modules\triggers\components\conditions\vendor\ConditionInterface;
use common\modules\triggers\models\TriggerCondition;
use common\modules\triggers\models\TriggerParam;
use common\modules\triggers\models\TriggerSchedule;
use common\modules\triggers\models\TriggerTrigger;
use yii\web\BadRequestHttpException;

class CheckPresenceTime extends ConditionBase implements ConditionInterface {
    const CONDITION_ID=5;

    public $name = 'Время присутствия на странице';

    public $params=[];

    /**
     * @param null|string $conditionName
     * @return $this mixed
     */
    public static function init($conditionName=__CLASS__){
        return parent::init($conditionName);
    }

    public function initScript($cron_time=180){
        // Получили список всех активных (актуальных) триггеров
        /** @var TriggerTrigger[] $actualTriggers */
        $actualTriggers = TriggerTrigger::getActualTriggers(self::CONDITION_ID);
        // Перебираем их в цикле
        foreach($actualTriggers as $trigger) {
            // Получили условия триггера на итерации
            $conditions = TriggerCondition::find()->where(['trigger_id' => $trigger->getPrimaryKey()])->all();
            // Перебираем все условия триггера на итерации
            foreach($conditions as $condition) {
                // Пытаемся получить параметр URL в условии
                /** @var TriggerParam $paramUrl */
                $paramUrl = TriggerParam::find()->where(['condition_id'=>$condition->getPrimaryKey(), 'key'=>'url'])->one();
                // Пытаемся получить параметр времени на условии
                /** @var TriggerParam $paramTime */
                $paramTime = TriggerParam::find()->where(['condition_id'=>$condition->getPrimaryKey(), 'key'=>'time'])->one();
                // Если сработали условия что триггер есть, у него указаны время и URL и при этом он является триггером ДАННОГО типа
                if ($condition->condition_id==self::CONDITION_ID && $paramUrl!==null && $paramUrl->value==\Yii::$app->request->getUrl() && $paramTime!==null) {
                    $now = new \DateTime();
                    $time = new \DateTime();
                    $time->modify('+ '.(((int)$trigger->timeout<(int)$cron_time) ? $cron_time : (int)$trigger->timeout+(int)$cron_time).' second');
                    // Заносим запись в базу
                    $model = new TriggerSchedule();
                    $model->sended = 0;
                    $model->checked = 0;
                    $model->message = 'Test the presence time';
                    $model->email = \common\modules\users\models\User::findOne(\Yii::$app->user->id)->email;
                    $model->time = $time->format('Y-m-d H:i:s');
                    $model->date_create = $now->format('Y-m-d H:i:s');
                    if ($model->save()) {
                        $view = \Yii::$app->controller->view;
                        // Создаем скрипт
                        $script ='$(document).ready(function() {
                                    var timer='.((int)$paramTime->value*1000).';
                                    setTimeout(function() {
                                        $.ajax({
                                            url: "/triggers/default/dropschedule",
                                            method: "GET",
                                            async: false,
                                            data: {
                                                id: '.$model->getPrimaryKey().'
                                            },
                                        });
                                    }, timer);
                                  });';
                        // Регистрируем его
                        $view->registerJs($script, $view::POS_READY);
                    } else {
                        throw new BadRequestHttpException(current(current($model->getErrors())), 500);
                    }
                }
            }
        }
    }

    /**
     * @param $time
     * @return bool
     */
    public function check($time){
        return true;
    }
} 